System.usbDiskModeActivate()
white = Color.new(255, 255, 255)
red = Color.new(255, 0, 0)
blue = Color.new(0, 0, 255)
black = Color.new(0, 0, 0)
menu = 1
background = Image.load("pics/background.png")
hor = Image.load("pics/hor.png")
vert = Image.load("pics/vert.png")
tjunct = Image.load("pics/tjunct.png")
ld = Image.load("pics/ld.png")
lu = Image.load("pics/lu.png")
rd = Image.load("pics/rd.png")
ru = Image.load("pics/ru.png")
Bhor = Image.load("pics/horblu.png")
Bvert = Image.load("pics/vertblu.png")
Btjunctfull = Image.load("pics/tjunctblufull.png")
Btjuncthor = Image.load("pics/tjunctbluhor.png")
Btjunctvert = Image.load("pics/tjunctbluvert.png")
Bld = Image.load("pics/ldblu.png")
Blu = Image.load("pics/lublu.png")
Brd = Image.load("pics/rdblu.png")
Bru = Image.load("pics/rublu.png")
border = Image.load("pics/border.png")
hiFile = "highscore.txt"
gametimer = Timer.new()

----------------------------------------------------------------
-- function to initialize new game
----------------------------------------------------------------

function initNewGame()
	size = 0
	x = 230
	y = 22
	xpos = {}
	ypos = {}
	prev = 0
	next = {}
	type = {}
	lvltime = 45 + 5 * level
	timestop = 0
	endtime = 0
	currtime = 1
	pleft = 5 * level

	marked = {}
	i = 0
	while i < 18 do
		marked[i] = {}
		j = 0
		while j < 18 do
			marked[i][j] = 0
			j = j + 1
		end
		i = i + 1
	end

	i = 0
	while i < 5 do
		next[i] = math.random(7)
		i = i + 1
	end

	startside = math.random(4)
	startpos = math.random(16)
	if startside == 1 then
		dirx = 0
		diry = 1
		startx = startpos
		starty = 0
	end
	if startside == 2 then
		dirx = 1
		diry = 0
		startx = 0
		starty = startpos
	end
	if startside == 3 then
		dirx = 0
		diry = -1
		startx = startpos
		starty = 17
	end
	if startside == 4 then
		dirx = -1
		diry = 0
		startx = 17
		starty = startpos
	end
	finishside = math.random(4)
	finishpos = math.random(16)
	while finishpos == startpos do
		while finishside == startside do
			finishside = math.random(4)
			finishpos = math.random(16)
		end
	end
	if finishside == 1 then
		finishx = finishpos
		finishy = 0
	end
	if finishside == 2 then
		finishx = 0
		finishy = finishpos
	end
	if finishside == 3 then
		finishx = finishpos
		finishy = 17
	end
	if finishside == 4 then
		finishx = 17
		finishy = finishpos
	end

	gametimer:reset()
	gametimer:start()
end

----------------------------------------------------------------
-- function to display "next" tiles
----------------------------------------------------------------

function dispNext()
	i = 0
	while i < 5 do
		j = 50 + 20 * i
		
		if next[i] == 1 then
			screen:blit(125, j, hor)
		end

		if next[i] == 2 then
			screen:blit(125, j, vert)
		end

		if next[i] == 3 then
			screen:blit(125, j, tjunct)
		end

		if next[i] == 4 then
			screen:blit(125, j, ld)
		end

		if next[i] == 5 then
			screen:blit(125, j, lu)
		end

		if next[i] == 6 then
			screen:blit(125, j, rd)
		end

		if next[i] == 7 then
			screen:blit(125, j, ru)
		end

		i = i + 1
	end
end

----------------------------------------------------------------
-- function to display marked tiles
----------------------------------------------------------------

function dispMarked()
	for i = 1, 16 do
		for j = 1, 16 do
			if marked[i][j] == 1 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, hor)
			end

			if marked[i][j] == 2 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, vert)
			end

			if marked[i][j] == 3 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, tjunct)
			end

			if marked[i][j] == 4 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, ld)
			end

			if marked[i][j] == 5 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, lu)
			end

			if marked[i][j] == 6 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, rd)
			end

			if marked[i][j] == 7 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, ru)
			end

			if marked[i][j] == 8 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Bhor)
			end

			if marked[i][j] == 9 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Bvert)
			end

			if marked[i][j] == 10 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Btjunctfull)
			end

			if marked[i][j] == 11 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Bld)
			end

			if marked[i][j] == 12 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Blu)
			end

			if marked[i][j] == 13 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Brd)
			end

			if marked[i][j] == 14 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Bru)
			end

			if marked[i][j] == 15 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Btjuncthor)
			end

			if marked[i][j] == 16 then
				screen:blit( 14 * (i - 1) + 232, 14 * (j - 1) + 24, Btjunctvert)
			end

		end
	end
end

----------------------------------------------------------------
-- function to display start/finish locations
----------------------------------------------------------------

function dispSF()
	if startside == 1 then
		screen:print(222 + 14 * startpos, 13, "S", red)
	end
	if startside == 3 then
		screen:print(222 + 14 * startpos, 250, "S", red)
	end
	if startside == 2 then
		screen:print(222, 13 + 14 * startpos, "S", red)
	end
	if startside == 4 then
		screen:print(458, 13 + 14 * startpos, "S", red)
	end
	if finishside == 1 then
		screen:print(222 + 14 * finishpos, 13, "F", red)
	end
	if finishside == 3 then
		screen:print(222 + 14 * finishpos, 250, "F", red)
	end
	if finishside == 2 then
		screen:print(222, 13 + 14 * finishpos, "F", red)
	end
	if finishside == 4 then
		screen:print(458, 13 + 14 * finishpos, "F", red)
	end
end

----------------------------------------------------------------
-- function to wait a given amount of loops
----------------------------------------------------------------

function buttonwait(limit)
	wait = 0
	while wait < limit do
		wait = wait + 1
	end
end

----------------------------------------------------------------
-- function to pause game
----------------------------------------------------------------

function pause()
	while true do
		screen:blit(0, 0, background, 0, 0, background:width(), background:height(), true)
		screen:print(72, 30, "Level: " .. level, white)
		screen:print(72, 50, "Next:", white)
		screen:print(72, 180, "Time: " .. currtime, white)
		screen:print(72, 200, "Pieces: " .. pleft, white)
		screen:print(72, 220, "Score: " .. score, white)

		screen.waitVblankStart()
		screen.flip()

		pad = Controls.read()
		if pad:start() then
			buttonwait(80000)
			break
		end
	end
end

----------------------------------------------------------------
-- function to save high score
----------------------------------------------------------------

function saveHi()
	file = io.open(hiFile, "w")
	if file then
		file:write(highscore)
		file:close()
	end
end

----------------------------------------------------------------
-- function to load high score
----------------------------------------------------------------

function loadHi()
	file = io.open(hiFile, "r")
	if file then
		highscore = file:read("*n")
		file:close()
	end
end

----------------------------------------------------------------
-- function to test pieces / run water through
----------------------------------------------------------------

function water()
	while win == 1 do
		screen:blit(0, 0, background, 0, 0, background:width(), background:height(), true)
		screen:print(72, 30, "Level: " .. level, white)
		screen:print(72, 50, "Next:", white)
		screen:print(72, 180, "Time: " .. endtime, white)
		screen:print(72, 200, "Pieces: " .. pleft, white)
		screen:print(72, 220, "Score: " .. score, white)

		dispSF()
		dispMarked()

		win = 0
		iterate = 0

		buttonwait(200000)

		if iterate == 0 then
			if dirx == 1 then
				iterate = 1
				startx = startx + 1
				next = marked[startx][starty]
				marked[startx][starty] = marked[startx][starty] + 7
				if next == 1 then win = 1 end
				if next == 3 then
					win = 1
					marked[startx][starty] = 15
				end
				if next == 16 then
					win = 1
					marked[startx][starty] = 10
				end
				if next == 4 then
					win = 1
					dirx = 0
					diry = 1
				end
				if next == 5 then
					win = 1
					dirx = 0
					diry = -1
				end
			end
		end
			
		if iterate == 0 then
			if dirx == -1 then
				iterate = 1
				startx = startx - 1
				next = marked[startx][starty]
				marked[startx][starty] = marked[startx][starty] + 7
				if next == 1 then win = 1 end
				if next == 3 then
					win = 1
					marked[startx][starty] = 15
				end
				if next == 16 then
					win = 1
					marked[startx][starty] = 10
				end
				if next == 6 then
					win = 1
					dirx = 0
					diry = 1
				end
				if next == 7 then
					win = 1
					dirx = 0
					diry = -1
				end
			end
		end

		if iterate == 0 then
			if diry == 1 then
				iterate = 1
				starty = starty + 1
				next = marked[startx][starty]
				marked[startx][starty] = marked[startx][starty] + 7
				if next == 2 then win = 1 end
				if next == 3 then
					win = 1
					marked[startx][starty] = 16
				end
				if next == 15 then
					win = 1
					marked[startx][starty] = 10
				end
				if next == 5 then
					win = 1
					dirx = -1
					diry = 0
				end
				if next == 7 then
					win = 1
					dirx = 1
					diry = 0
				end
			end
		end

		if iterate == 0 then
			if diry == -1 then
				iterate = 1
				starty = starty - 1
				next = marked[startx][starty]
				marked[startx][starty] = marked[startx][starty] + 7
				if next == 2 then win = 1 end
				if next == 3 then
					win = 1
					marked[startx][starty] = 16
				end
				if next == 15 then
					win = 1
					marked[startx][starty] = 10
				end
				if next == 4 then
					win = 1
					dirx = -1
					diry = 0
				end
				if next == 6 then
					win = 1
					dirx = 1
					diry = 0
				end
			end
		end

		if startx == finishx then
			if starty == finishy then
				wingame = 1
				return
			end
		end

		screen.waitVblankStart()
		screen.flip()

		if pleft > 0 then
			pleft = pleft - 1
		end

		score = score + 10

	end
end

----------------------------------------------------------------
-- function of actual game
----------------------------------------------------------------

function newgame()
	while currtime ~= 0 do
		if x < 230 then
			x = 230
		end

		if x > 440 then
			x = 440
		end

		if y < 22 then
			y = 22
		end

		if y > 232 then
			y = 232
		end

		screen:blit(0, 0, background, 0, 0, background:width(), background:height(), true)
	 	screen:blit(x, y, border)
		screen:print(72, 30, "Level: " .. level, white)
		screen:print(72, 50, "Next:", white)
		if timestop ~= 1 then
			currtime = lvltime - math.floor(gametimer:time()/1000)
		end
		if timestop == 1 then
			currtime = 0
		end
		screen:print(72, 180, "Time: " .. currtime, white)
		screen:print(72, 200, "Pieces: " .. pleft, white)
		screen:print(72, 220, "Score: " .. score, white)

		if timestop ~= 1 then
			if currtime == 0 then
				gametimer:stop()
			end
		end

		dispSF()
		dispMarked()
		dispNext()

		screen.waitVblankStart()
		screen.flip()
 	
		pad = Controls.read()

		if pad:r() then
			buttonwait(250000)
			gametimer:stop()
			endtime = currtime
			timestop = 1
			currtime = 0
		end

		if pad:start() then
			gametimer:stop()
			buttonwait(80000)
			pause()
			gametimer:start()
		end

		if pad:circle() then
			xpos[size] = x
			ypos[size] = y
			type[size] = next[4]
			xm = math.floor( (x - 230) / 14) + 1
			ym = math.floor( (y - 22) / 14) + 1
			marked[xm][ym] = next[4]
			next[4] = next[3]
			next[3] = next[2]
			next[2] = next[1]
			next[1] = next[0]
			next[0] = math.random(7)
	
			size = size + 1

			buttonwait(50000)
			curr = 5
		end

		if pad:right() then
			x=x+14
			curr = 1

			buttonwait(30000)
		end

		if pad:left() then
			x=x-14
			curr = 2

			buttonwait(30000)
		end

		if pad:down() then
			y=y+14
			curr = 3

			buttonwait(30000)
		end
	
		if pad:up() then
			y=y-14
			curr = 4

			buttonwait(30000)
		end

		if curr == prev then
			buttonwait(10000)
		end
		curr = prev

		if pad:l() then
			buttonwait(100000)
			gametimer:stop()
			wingame = 0
			return
		end
	end
end

----------------------------------------------------------------
-- function to display that user has finished game
----------------------------------------------------------------
function youWon()
	while true do
		screen:fillRect(0, 0, 480, 272, black)
		screen:print(1, 1, "Congratulations, you beat the game!", white)
		screen:print(1, 262, "Hit L to continue.", white)

		screen.waitVblankStart()
		screen.flip()

		pad = Controls.read()
		if pad:l() then
			buttonwait(100000)
			break
		end
	end
end	

----------------------------------------------------------------
-- function to play game in a level loop
----------------------------------------------------------------

function startnewgame()
	while wingame == 1 do
		level = level + 1

		if level == 11 then
			youWon()
		end

		if level < 11 then
			initNewGame()
			newgame()

			win = 1
			wingame = 0
			water()
			if pleft > 0 then
				wingame = 0
			end

			score = score + endtime*10
			startnewgame()
		end
	end
end

----------------------------------------------------------------
-- display credits
----------------------------------------------------------------
function instructions()
	while true do
		screen:fillRect(0, 0, 480, 272, black)
		screen:print(1, 1, "-Move around with the arrow keys.", white)
		screen:print(1, 21, "-Place a tile with O (circle).", white)
		screen:print(1, 41, "-Pause game with Start.", white)
		screen:print(1, 61, "-Quit current game with L.", white)
		screen:print(1, 81, "-Finish current level with R (stop time).", white)
		screen:print(1, 252, "Hit L to continue.", white)
		screen:print(1, 262, "Created by Paul Webster.", white)

		screen.waitVblankStart()
		screen.flip()

		pad = Controls.read()
		if pad:l() then
			buttonwait(100000)
			break
		end
	end
end		

----------------------------------------------------------------
-- main function
----------------------------------------------------------------

while true do
	loadHi()

	screen:fillRect(0, 0 , 480, 272, black)
	screen:print(110, 1, "P I P E   S U E N O   V 1 . 0", blue)
	screen:print(180, 50, "New Game", white)
	screen:print(180, 100, "Instructions", white)
	screen:print(180, 150, "Exit", white)
	screen:print(1, 262, "High Score: " .. highscore, white)

	if menu == 1 then
		screen:print(180, 50, "New Game", red)
	end
	if menu == 2 then
		screen:print(180, 100, "Instructions", red)
	end
	if menu == 3 then
		screen:print(180, 150, "Exit", red)
	end

	screen.waitVblankStart()
	screen.flip()

	pad = Controls.read()
	if pad:l() then
		break
	end

	if pad:circle() then
		if menu == 1 then
			buttonwait(100000)
			level = 0
			score = 0
			wingame = 1

			startnewgame()
			
			if score > highscore then
				highscore = score
				saveHi()
			end
		end
		if menu == 2 then
			buttonwait(100000)
			instructions()
		end
		if menu == 3 then
			break
		end
	end

	if pad:up() then
		menu = menu - 1
		if menu < 1 then
			menu = 3
		end
	end

	if pad:down() then
		menu = menu + 1
		if menu > 3 then
			menu = 1
		end
	end
	
	buttonwait(30000)
end


